.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include	plprocs.h

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib




.data?
	bread		dd	?
	hInstance	dd	?
	SendToAll	dd	?
	RegisterCommand	dd	?
	UnregisterCommand dd	?
	RegisterHelpString dd	?
	UnregisterHelpString dd	?
	NickFromId	dd	?
	SendTo		dd	?
	GetUserCount	dd	?
	GetUserIds	dd	?
	GetIP		dd	?
	hBlocklist	dd	?
	hBlocklisth	dd	?
	blocked		dd	?
	ips		dd	?
	datafile	db	8192 dup(?)
	qfile		db	8192 dup(?)
	ipuri		dd	512*1024*2 dup(?)
	pointeri	dd	512*1024 dup(?)
	bufmsg		db	32768 dup(?)
	hlptmp		db	32768 dup(?)
	buftmp		db	32768 dup(?)

.code
pluginName	db	'Blacklist v1.00 - database from http://peerguardian.sourceforge.net/lists/ ',0
_about		db	'Albu Cristian, 2008',0
fn01		db	'SendToAll',0
fn02		db	'GetUserCount',0
fn03		db	'GetUserIds',0
fn03a		db	'GetIP',0
fn04		db	'RegisterCommand',0
fn05		db	'UnregisterCommand',0
fn06		db	'RegisterHelpString',0
fn07		db	'UnregisterHelpString',0
fn08		db	'NickFromId',0
fn09		db	'SendTo',0
pl_procs

GetAboutText	PROC
	mov	eax,offset _about
	ret
GetAboutText	ENDP

DllEntry PROC dllInstance:DWORD,reason:DWORD,reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		push	dllInstance
		pop	hInstance
	.elseif reason==DLL_PROCESS_DETACH
	.elseif reason==DLL_THREAD_ATTACH
	.else
	.endif
	xor	eax,eax
	inc	eax
	ret
DllEntry Endp

reghlp:	mov	ecx,edi
	mov	al,'!'
	stosb
	.while byte ptr[esi]
		movsb
	.endw
	mov	eax,92d0909h
	stosd
	call	copyedx
	mov	al,0
	stosb
	dec	edi
	inc	edi
	ret

block1	db	'blacklist',0
block1h	db	'!blacklist		-	show blacklisted users',0

regcmds:push	offset procfn
	push	offset block1
	call	RegisterCommand
	mov	hBlocklist,eax

	push	6
	push	offset block1h
	push	offset block1h-1
	call	RegisterHelpString
	mov	hBlocklisth,eax
	ret

unregcmds:
	push	hBlocklist
	call	UnregisterCommand
	mov	hBlocklist,0
	push	hBlocklisth
	call	UnregisterHelpString
	mov	hBlocklisth,0
	ret



InitPlugin	PROC	uses esi edi ebx GetAddr:DWORD
	mov	blocked,0
	call	getdatafile
	lea	esi,datafile
	lea	edi,qfile
	mov	ecx,edi
	.while byte ptr[esi]
		lodsb
		.if al=='.'
			mov	ecx,edi
		.endif
		stosb
	.endw
	mov	edi,ecx
	mov	eax,'txt.'
	stosd
	mov	al,0
	stosb
	invoke	CreateFile,addr qfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		invoke	GetFileSize,eax,0
		lea	ecx,[eax+1024]
		push	eax
		invoke	GlobalAlloc,GPTR,ecx
		pop	ecx
		mov	esi,eax
		pop	eax
		push	eax
		invoke	ReadFile,eax,esi,ecx,addr bread,0
		mov	eax,esi
		add	eax,bread
		mov	byte ptr[eax],0
		call	CloseHandle
		mov	blocked,esi
		lea	edi,ipuri
		xor	ecx,ecx
		.while byte ptr[esi]
			mov	eax,esi
			mov	pointeri[ecx*4],eax
			.while (byte ptr[esi]!=':')&&(byte ptr[esi]!=13)&&(byte ptr[esi]!=10)&&(byte ptr[esi]!=0)
				inc	esi
			.endw
			.if byte ptr[esi]==':'
				inc	esi
				push	ecx
				call	getrange
				.if eax==0
					dec	eax
				.endif
				pop	ecx
				xchg	al,ah
				rol	eax,16
				xchg	al,ah
				mov	ipuri[ecx*8],eax
				xchg	bl,bh
				rol	ebx,16
				xchg	bl,bh
				mov	ipuri[ecx*8+4],ebx
			.else
				xor	eax,eax
				dec	eax
				mov	ipuri[ecx*8],eax
				mov	ipuri[ecx*8+4],eax
			.endif
			.while (byte ptr[esi]!=13)&&(byte ptr[esi]!=10)&&(byte ptr[esi]!=0)
				inc	esi
			.endw
			.while (byte ptr[esi]==13)||(byte ptr[esi]==10)
				inc	esi
			.endw
			inc	ecx
		.endw
		mov	ipuri[ecx*8],0
		mov	ipuri[ecx*8+4],0
		mov	ips,ecx
	.endif

	push	offset fn01
	call	GetAddr
	mov	SendToAll,eax
	push	offset fn02
	call	GetAddr
	mov	GetUserCount,eax
	push	offset fn03
	call	GetAddr
	mov	GetUserIds,eax
	push	offset fn03a
	call	GetAddr
	mov	GetIP,eax
	push	offset fn04
	call	GetAddr
	mov	RegisterCommand,eax
	push	offset fn05
	call	GetAddr
	mov	UnregisterCommand,eax
	push	offset fn06
	call	GetAddr
	mov	RegisterHelpString,eax
	push	offset fn07
	call	GetAddr
	mov	UnregisterHelpString,eax
	push	offset fn08
	call	GetAddr
	mov	NickFromId,eax
	push	offset fn09
	call	GetAddr
	mov	SendTo,eax

	call	regcmds
	lea	eax,pluginName
	ret
InitPlugin	ENDP

UnloadPlugin	PROC uses esi
	call	unregcmds
	.if blocked
		invoke	GlobalFree,blocked
	.endif
	ret
UnloadPlugin	ENDP

SaveSettings	PROC uses esi edi
	ret
SaveSettings	ENDP

isblocked:
	push	edi
	mov	ecx,ips
	lea	edi,ipuri
	xchg	al,ah
	rol	eax,16
	xchg	al,ah
	lea	ebx,pointeri
	.while (ecx!=0)
		.if (eax>=[edi])&&(eax<=[edi+4])&&(dword ptr[edi]!=0)&&(dword ptr[edi]!=-1)
			push	ecx
			push	edi
			mov	edi,[esp+8]
			mov	al,9
			stosb
			push	edi
			push	dword ptr[esi-4]
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	al,9
			stosb
			push	edi
			push	dword ptr[esi-4]
			call	GetIP
			pop	edi
			call	w_ip
			mov	al,9
			stosb
			mov	edx,[ebx]
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=13)&&(byte ptr[edx]!=10)&&(byte ptr[edx]!=':')
				mov	al,[edx]
				.if al=='|'
					mov	al,32
				.endif
				stosb
				inc	edx
			.endw
			mov	ax,0a0dh
			stosw
			mov	[esp+8],edi
			pop	edi
			mov	eax,[esi-4]
			xchg	al,ah
			rol	eax,16
			xchg	al,ah
			pop	ecx
		.endif
		lea	edi,[edi+8]
		lea	ebx,[ebx+4]
		dec	ecx
	.endw
	pop	edi
	ret

msg1	db	'*** The following users were found in selected blacklist:',13,10,13,10,0
procfn	PROC	uses esi edi ebx cmdID:DWORD,userId:DWORD,lpRights:DWORD,lpParams:DWORD,isPM:DWORD
	local	users:DWORD,ids:DWORD
	mov	eax,cmdID
	.if (eax==hBlocklist)
		call	GetUserCount
		mov	users,eax
		inc	eax
		shl	eax,2
		invoke	GlobalAlloc,GPTR,eax
		mov	ids,eax
		push	users
		push	eax
		call	GetUserIds
		invoke	GlobalAlloc,GPTR,1024
		push	eax
		mov	edi,eax
		lea	edx,msg1
		call	copyedx
		mov	ecx,users
		mov	esi,ids
		.while ecx
			push	ecx
			lodsd
			push	edi
			push	eax
			call	GetIP
			pop	edi
			.if (eax!=0)&&(eax!=-1)&&(eax!=0100007fh)
				call	isblocked
			.endif
			pop	ecx
			mov	eax,edi
			sub	eax,dword ptr[esp]
			.break .if eax>10240
			dec	ecx
		.endw
		mov	al,'|'
		stosb
		mov	ecx,edi
		mov	edi,[esp]
		sub	ecx,edi
		push	ecx
		push	edi
		push	userId
		call	SendTo
		call	GlobalFree
		invoke	GlobalFree,ids
	.endif
	ret
procfn	ENDP

End DllEntry
